#!/usr/local/bin/python3
##################################################################################################
# SCRIPT NAME      : db_deploy.py
# DESCRIPTION      : propose for deploy file.sql for ddl & data
#                      - {tablename}_data.sql
#                      - {tablename}_ddl.sql
#                    on Database build stage
# AUTHOR           : Suebsakul Ampa
# CREATED DATE     : 03/11/2021
# USAGE            : ./db_deploy.sh {ENV} {DB_PATH} {SQL_TYPE}
#-------------------------------------------------------------------------------------------------
# CHANGED REVISION
#
# UPDATED BY       : Suebsakul Ampa
# UPDATED DATE     : 03/11/2021
# Initial version
#
# UPDATED BY       : Suebsakul Ampa
# UPDATED DATE     : 
#
##################################################################################################

import pandas as pd
import logging
import sys, getopt
import os, shutil
import re
from datetime import datetime
import time
import glob

from pathlib import Path
#module sql statment
# import sqlparse
# import sql_metadata

#module DB
import mariadb
import vertica_python
from impala.dbapi import connect

import uuid
import difflib
from difflib import Differ


#change directory
# only debug mode
# os.chdir('D:\\Workspace\\TOP_Crude_Flex\\Monitor\\etl\\bin\\')
PWD = os.getcwd()

os.chdir('D:\\Workspace\\Auto_Deploy\\CodeDeploy\\' if "win" in sys.platform else PWD+'/CodeDeploy/')

# insert at 1, 0 is the script path (or '' in REPL)
# sys.path.insert(0, '../libs')
import python_libs   as Mylib
import folder_libs   as Folderlib
import variable_libs as Varlib

# sys.path.insert(0, '..')
# from libs import python_libs as Mylib
# from libs import folder_libs as Folderlib

#----------------------------------------- Variable ------------------------------------------
# define veriable
Mylib.EXEC_PARA='-e <ENV Feature, Develop, QA or Production> -p <Root DB Path> -t <Type DDL or DATA> -f <Full File.sql> -b <Build Number> -a <Action Deploy>'
DB_CHAR  = "utf8"

vertica_conn_info = {
                        'host': 'db_vertica',
                        'port': 5433,
                        'user': 'dbadmin',
                        # autogenerated session label by default,
                        'session_label': 'Auto Deploy',
                        # default throw error on invalid UTF-8 results
                        'unicode_error': 'strict',
                        # SSL is disabled by default
                        'ssl': False,
                        # autocommit is off by default
                        'autocommit': False,
                        # using server-side prepared statements is disabled by default
                        # 'use_prepared_statements': False,
                        # connection timeout is not enabled by default
                        # 5 seconds timeout for a socket operation (Establishing a TCP connection or read/write operation)
                        'connection_timeout': 5}

mysql_conn_info = {
                        'host':     "db_mariadb",
                        'port':      3306,
                        'user':     "root",
                        'password': "example"}

impala_conn_info = {
                        'host' :'my.host.com',
                        'port' :21050}                        

folder_lib = Folderlib._folder()


if len(sys.argv) <= 1 :
    Mylib._usage(sys.argv)

commandline_argment = Mylib._commandline_argment()

try:
    opts, args = getopt.getopt(sys.argv[1:],"he:p:t:f:a:b:",["env=","path=","type="])

    for (o, v) in opts:
        if o == '-e':
            # file_load = v
            commandline_argment.add('env',v)
        elif o == '-p':
            commandline_argment.add('db_path',v)
        elif o == '-t':
            commandline_argment.add('sql_type',v)
        elif o == '-f':
            commandline_argment.add('file_sql',v)
        elif o == '-a':
            commandline_argment.add('action',v)
        elif o == '-b':
            commandline_argment.add('BUILD_NUMBER',v)
        elif o == '-h':
            Mylib._usage(sys.argv)
        else:
            # sys.stderr.write("%s: illegal option '%s'\n" % (args[0], o))
            # log.error("%s: illegal option '%s'\n" % (args[0], o))
            Mylib._usage(sys.argv)
except:
    Mylib._usage(sys.argv)

# #assign default argment
# if commandline_argment.get('Mode') == None:
#     commandline_argment.add('Mode','default')

#assign uuid.uuid1()
UUID = str(uuid.uuid1())
commandline_argment.add('uuid',UUID)

#----------------------------------------- Function ------------------------------------------
def load_rules_replaces(file_rules_replace):

    df = pd.read_excel(file_rules_replace)

    # Filter only active and same DB Path
    df_rules_replace = df[(df.Status.str.lower() == 'Active'.lower()) & (df.DB_PATH.str.lower() == commandline_argment.get('DB_PATH').lower())]
    log.info('Filename : %s on Sheet: = %d record(s)' % (file_rules_replace, len(df_rules_replace)))                                

    return df_rules_replace

#------------------------------------------- Main --------------------------------------------

# define loggin
start_time = time.time()
log = logging.getLogger() # 'root' Logger

# logging.basicConfig(filename='myapp.log', level=logging.INFO, format='[%(asctime)s] {%(filename)s:%(lineno)d} %(levelname)s - %(message)s')
log.info("start")
log.info("log level : %s" % logging.getLevelName(log.level))



# list argments
commandline_argment.list()

var_config_db_vertica = Varlib._var_db_vertica()
var_config_db_mysql   = Varlib._var_db_mysql()
var_config_db_impala  = Varlib._var_db_impala()
connection = None

try:

    # list file.sql follow condition below
    # <DB_PATH>\<SCHEMA>\ddl\<tablename>_ddl.sql
    # <DB_PATH>\<SCHEMA>\data\<tablename>_data.sql    

    file_sql = folder_lib.cnv_path(PWD +'/'+ commandline_argment.get('file_sql'))
    if os.access(file_sql, os.R_OK) == False:    
        log.error("can't access read file : %s" % file_sql)
        sys.exit(2)
    else:
        log.info("Found : %s" % file_sql)

        f = open(file_sql, mode="r", encoding="utf-8")
        file_content_sql = f.read()            
        f.close()       

    # Process Action between deploy or rollback

    # Split by DB Type
    # if   commandline_argment.get('DB_PATH').lower() == "DB_Vertica".lower():
    # elif commandline_argment.get('DB_PATH').lower() == "DB_MySQL".lower():
    # elif commandline_argment.get('DB_PATH').lower() == "DB_Impala".lower():
    # else:
    #     log.error("ERROR Unknow DB TYPE : %s" % commandline_argment.get('DB_PATH'))
    #     sys.exit(2)

    if   commandline_argment.get('DB_PATH') == "DB_Impala" :
        connection = connect(**impala_conn_info)
        var_config = var_config_db_impala
    elif commandline_argment.get('DB_PATH') == "DB_Vertica":
        connection = vertica_python.connect(**vertica_conn_info)
        var_config = var_config_db_vertica
    elif commandline_argment.get('DB_PATH') == "DB_MySQL"   :
        connection = mariadb.connect(**mysql_conn_info)        
        var_config = var_config_db_mysql
    else:
        log.error("Unknow database type : %s" % commandline_argment.get('DB_PATH'))
        sys.exit(2)

    # SQL Type
    if   commandline_argment.get('sql_type').lower() == "ddl":

        # connect db
        cur = connection.cursor()
        
        # Recheck one statement
        # must only statment CREATE TABLE
        search_regx = re.search(r"CREATE TABLE ([A-Za-z1-9_]*)\.([A-Za-z1-9_]*)", file_content_sql, re.IGNORECASE)

        if search_regx == None:
            log.error("ERROR Not found prefix table or tablename or Not found statement 'Create table'")
            sys.exit(2)
        else:
            PREFIX_DB  = search_regx.group(1)
            TABLE_NAME = search_regx.group(2)


        # get table name
        
        if   commandline_argment.get('ACTION').upper() == "A": # Add

            log.info("Content : %s" % file_content_sql)

            # do things
            build_sql = Mylib._dynamic_sql(commandline_argment.get('DB_PATH'))

            build_sql.add_scalar('SCHEMA'    ,PREFIX_DB)
            build_sql.add_scalar('TABLE_NAME',TABLE_NAME)

            SQL_CHK_TABLE = build_sql.build_sql_dynamic(var_config.SQL_CHK_TABLE())

            log.info(SQL_CHK_TABLE)

            cur.execute(SQL_CHK_TABLE)
            NUMBER_OF_RECORD=cur.fetchone()[0]
            log.info(NUMBER_OF_RECORD)
            
            if NUMBER_OF_RECORD > 0 :
                log.error("ERROR Found Table : %s on Database on Action %s" % (PREFIX_DB + "." + TABLE_NAME,commandline_argment.get('ACTION')))
                sys.exit(2)
            else:
                log.info("Pass Result : %d Not have table %s on database" % (NUMBER_OF_RECORD,PREFIX_DB + "." + TABLE_NAME))    

            log.info("execute ddl statement on file: %s" % file_sql)
            cur.execute(file_content_sql)

            # Add comment on Table
            cur.execute("COMMENT ON TABLE %s.%s IS 'Create by Automate Deploy on Build %s';" % (PREFIX_DB,TABLE_NAME,commandline_argment.get('BUILD_NUMBER')))
            

            log.info("Create new table: %s done." % PREFIX_DB + "." + TABLE_NAME)

        elif commandline_argment.get('ACTION').upper() == "R": # Rename
            log.info("Rename to backup table")

            build_sql = Mylib._dynamic_sql(commandline_argment.get('DB_PATH'))

            build_sql.add_scalar('SCHEMA'    ,PREFIX_DB)
            build_sql.add_scalar('TABLE_NAME',TABLE_NAME)
            build_sql.add_scalar('DATETIME',datetime.today().strftime('%Y%m%d_%H%M%S'))
            build_sql.add_scalar('BUILD_NUMBER',commandline_argment.get('BUILD_NUMBER'))

            SQL_CHK_TABLE    = build_sql.build_sql_dynamic(var_config.SQL_CHK_TABLE())
            SQL_RENAME_TABLE = build_sql.build_sql_dynamic(var_config.SQL_RENAME_TABLE())

            cur.execute(SQL_CHK_TABLE)
            NUMBER_OF_RECORD=cur.fetchone()[0]
            log.info(NUMBER_OF_RECORD)
            
            if NUMBER_OF_RECORD != 1 :
                log.error("ERROR Not Found Table : %s on Database on Action %s" % (PREFIX_DB + "." + TABLE_NAME,commandline_argment.get('ACTION')))
                sys.exit(2)
            else:
                log.info("Pass Result : %d found table %s on database" % (NUMBER_OF_RECORD,PREFIX_DB + "." + TABLE_NAME))                

            log.info("Execute Rollback : %s" % SQL_RENAME_TABLE)
            cur.execute(SQL_RENAME_TABLE)

            log.info("Rename table: %s done." % PREFIX_DB + "." + TABLE_NAME)

        elif commandline_argment.get('ACTION').upper() == "D": # Delete
            log.info("--------------------------------------------------------------------------------------------------")
            log.info("|          Skip because on current not support this feature modify ddl file.sql.                 |")
            log.info("--------------------------------------------------------------------------------------------------")

        elif commandline_argment.get('ACTION').upper() == "M": # Modify
            log.info("--------------------------------------------------------------------------------------------------")
            log.info("|          Skip because on current not support this feature modify ddl file.sql.                 |")
            log.info("--------------------------------------------------------------------------------------------------")

        else:
            log.error("ERROR Unknow Action : %s" % commandline_argment.get('ACTION'))
            sys.exit(2)
        
        
    elif commandline_argment.get('sql_type').lower() == "data":

        # connect db
        cur = connection.cursor()
        
        # Recheck one statement
        # must only statment CREATE TABLE

        # search for get table name
        search_regx = re.search(r"\/data\/([A-Za-z1-9_]*)_data.sql$", commandline_argment.get('file_sql'), re.IGNORECASE)

        if search_regx == None:
            log.error("ERROR Not found prefix table or tablename or Not found statement 'Create table'")
            sys.exit(2)
        else:
            TABLE_NAME = search_regx.group(1)
        
        log.info("Content : %s" % file_content_sql)

        # search for get schema
        search_regx = re.search(r" ([A-Za-z1-9_]*)\.("+TABLE_NAME+") ", file_content_sql, re.IGNORECASE)

        if search_regx == None:
            log.error("ERROR Not found prefix table or tablename or Not found statement sql")
            sys.exit(2)
        else:
            PREFIX_DB = search_regx.group(1)    

        # log.info("PREFIX_DB : %s" % PREFIX_DB)            
        # log.info("TABLE_NAME : %s" % TABLE_NAME)            
        
        if   commandline_argment.get('ACTION').upper() == "A": # Add
            # log.info("Content : %s" % file_content_sql)

            # do things
            build_sql = Mylib._dynamic_sql(commandline_argment.get('DB_PATH'))

            build_sql.add_scalar('SCHEMA'      ,PREFIX_DB)
            build_sql.add_scalar('TABLE_NAME'  ,TABLE_NAME)
            build_sql.add_scalar('BUILD_NUMBER',commandline_argment.get('BUILD_NUMBER'))
            build_sql.add_scalar('DATETIME'    ,datetime.today().strftime('%Y%m%d_%H%M%S'))

            SQL_CHK_TABLE = build_sql.build_sql_dynamic(var_config.SQL_CHK_TABLE())

            log.info(SQL_CHK_TABLE)

            cur.execute(SQL_CHK_TABLE)
            NUMBER_OF_RECORD=cur.fetchone()[0]
            log.info(NUMBER_OF_RECORD)
            
            if NUMBER_OF_RECORD == 0 :
                log.error("ERROR Not Found Table : %s on Database on Action %s" % (PREFIX_DB + "." + TABLE_NAME,commandline_argment.get('ACTION')))
                sys.exit(2)
            else:
                log.info("Pass Result : %d have table %s on database" % (NUMBER_OF_RECORD,PREFIX_DB + "." + TABLE_NAME))

            # Backup existsing table
            SQL_CLONE_TABLE = build_sql.build_sql_dynamic(var_config.SQL_CLONE_TABLE())
            log.info(SQL_CLONE_TABLE)
            cur.execute(SQL_CLONE_TABLE)

            log.info("execute sql statement on file: %s" % file_sql)
            
            total_record=0
            count=0
            str_SQL = file_content_sql.strip()
            number_statement = len(str_SQL.split(';\n'))
            for statement in str_SQL.split(';\n'):
                
                if statement != None and statement != "":
                    count+=1
                    
                    # trim space and blank line
                    statement = statement.strip()

                    # remove comment e.g. -- Command --
                    statement = re.sub(r'\-\-.*\n', '', statement)

                    log.info(f'Statement {count}/{number_statement} : \n{statement}')
                    cur.execute(statement)

                    log.info(f'Update Rows: {cur.rowcount} record(s)\n')

                    total_record = total_record + cur.rowcount
            
            connection.commit()

            log.info(f'Total: {total_record} record(s)\n')


        elif commandline_argment.get('ACTION').upper() == "M": # Modify

            # do things
            build_sql = Mylib._dynamic_sql(commandline_argment.get('DB_PATH'))

            build_sql.add_scalar('SCHEMA'    ,PREFIX_DB)
            build_sql.add_scalar('TABLE_NAME',TABLE_NAME)

            SQL_CHK_TABLE = build_sql.build_sql_dynamic(var_config.SQL_CHK_TABLE())

            log.info(SQL_CHK_TABLE)

            cur.execute(SQL_CHK_TABLE)
            NUMBER_OF_RECORD=cur.fetchone()[0]
            log.info(NUMBER_OF_RECORD)
            
            if NUMBER_OF_RECORD == 0 :
                log.error("ERROR Not Found Table : %s on Database on Action %s" % (PREFIX_DB + "." + TABLE_NAME,commandline_argment.get('ACTION')))
                sys.exit(2)
            else:
                log.info("Pass Result : %d have table %s on database" % (NUMBER_OF_RECORD,PREFIX_DB + "." + TABLE_NAME))

            total_record=0
            count=0
            str_SQL = file_content_sql.strip()
            number_statement = len(str_SQL.split(';\n'))
            for statement in str_SQL.split(';\n'):
                
                if statement != None and statement != "":
                    count+=1
                    
                    # trim space and blank line
                    statement = statement.strip()

                    # remove comment e.g. -- Command --
                    statement = re.sub(r'\-\-.*\n', '', statement)

                    log.info(f'Statement {count}/{number_statement} : \n{statement}')

                    # ignore error only case duplicate key
                    try:
                        cur.execute(statement)                    
                    except Exception as e:
                        
                        print(f"Error: {e}")                          

                        m = str(e)

                        if "Duplicate entry" in m:
                            pass
                        else:
                            raise

                    log.info(f'Update Rows: {cur.rowcount} record(s)\n')

                    # short-circuiting (0 if cur.rowcount < 0 else cur.rowcount)                    
                    total_record = total_record + (0 if cur.rowcount < 0 else cur.rowcount)

            connection.commit()

            log.info(f'Total: {total_record} record(s)\n')
            

        elif commandline_argment.get('ACTION').upper() == "R": # Rollback
            # log.info("--------------------------------------------------------------------------------------------------")
            # log.info("|                                TBD                                                             |")
            # log.info("--------------------------------------------------------------------------------------------------")
            # sys.exit(2)

            build_sql = Mylib._dynamic_sql(commandline_argment.get('DB_PATH'))

            build_sql.add_scalar('SCHEMA'      ,PREFIX_DB)
            build_sql.add_scalar('TABLE_NAME'  ,TABLE_NAME)
            build_sql.add_scalar('BUILD_NUMBER',commandline_argment.get('BUILD_NUMBER'))
            build_sql.add_scalar('DATETIME'    ,datetime.today().strftime('%Y%m%d_%H%M%S'))

            SQL_CHK_TABLE = build_sql.build_sql_dynamic(var_config.SQL_CHK_TABLE())

            log.info(SQL_CHK_TABLE)

            cur.execute(SQL_CHK_TABLE)
            NUMBER_OF_RECORD=cur.fetchone()[0]
            log.info(NUMBER_OF_RECORD)
            
            if NUMBER_OF_RECORD == 0 :
                log.error("ERROR Not Found Table : %s on Database on Action %s" % (PREFIX_DB + "." + TABLE_NAME,commandline_argment.get('ACTION')))
                sys.exit(2)
            else:
                log.info("Pass Result : %d have table %s on database" % (NUMBER_OF_RECORD,PREFIX_DB + "." + TABLE_NAME))

            SQL_GET_LAST_BAK_TABLE = build_sql.build_sql_dynamic(var_config.SQL_GET_LAST_BAK_TABLE())
            log.info(SQL_GET_LAST_BAK_TABLE)
            cur.execute(SQL_GET_LAST_BAK_TABLE)
            
            ROW = cur.fetchall()
            NUMBER_OF_RECORD = cur.rowcount

            if NUMBER_OF_RECORD == 0 :
                log.error("ERROR Not Found Table Backup : %s on Database on Action %s" % (PREFIX_DB + ".ZBK_" + TABLE_NAME + "_" + commandline_argment.get('BUILD_NUMBER') + "_YYYYMMDD_HHMMSS" ,commandline_argment.get('ACTION')))
                sys.exit(2)                
            else :
                log.info(NUMBER_OF_RECORD)

                TABLE_BACKUP=ROW[0][0]

                log.info("Pass Result : %s Table Backup on database" % (PREFIX_DB + "." + TABLE_BACKUP))

                build_sql.add_scalar('TABLE_BACKUP',TABLE_BACKUP)
                

                SQL_ROLLBACK_TABLE_CURR_TO_ROLL = build_sql.build_sql_dynamic(var_config.SQL_ROLLBACK_TABLE_CURR_TO_ROLL())
                SQL_ROLLBACK_TABLE_BAK_TO_CURR  = build_sql.build_sql_dynamic(var_config.SQL_ROLLBACK_TABLE_BAK_TO_CURR())
                
                log.info("Execute Rollback : %s" % SQL_ROLLBACK_TABLE_CURR_TO_ROLL)
                cur.execute(SQL_ROLLBACK_TABLE_CURR_TO_ROLL)

                log.info("Execute Rollback : %s" % SQL_ROLLBACK_TABLE_BAK_TO_CURR)
                cur.execute(SQL_ROLLBACK_TABLE_BAK_TO_CURR)


        elif commandline_argment.get('ACTION').upper() == "D": # Delete
            log.info("--------------------------------------------------------------------------------------------------")
            log.info("|          Skip because on current not support this feature modify ddl file.sql.                 |")
            log.info("--------------------------------------------------------------------------------------------------")

        else:
            log.error("ERROR Unknow Action : %s" % commandline_argment.get('ACTION'))
            sys.exit(2)


    else:
        log.error("ERROR Unknow SQL TYPE : %s" % commandline_argment.get('sql_type'))
        sys.exit(2)        

    log.info("done")

except Exception as e:
    print(f"Error: {e}")  
    log.error(f'Error: {e}')     

    connection.rollback() 

    sys.exit(2)
finally:
    if connection != None:        
        cur.close()
        connection.close()            
